# Copyright (C) 1999 by Juergen Pfeifer
# Ada for Linux Team (ALT)
#
# Permission is hereby granted, free of charge, to any person obtaining a  
# copy of this software and associated documentation files (the            
# "Software"), to deal in the Software without restriction, including      
# without limitation the rights to use, copy, modify, merge, publish,      
# distribute, distribute with modifications, sublicense, and/or sell       
# copies of the Software, and to permit persons to whom the Software is    
# furnished to do so, subject to the following conditions:                 
#                                                                          
# The above copyright notice and this permission notice shall be included  
# in all copies or substantial portions of the Software.                   
#                                                                          
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS  
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF               
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.   
# IN NO EVENT SHALL THE ABOVE COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,   
# DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR    
# OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR    
# THE USE OR OTHER DEALINGS IN THE SOFTWARE.                               
#                                                                          
# Except as contained in this notice, the name(s) of the above copyright   
# holders shall not be used in advertising or otherwise to promote the     
# sale, use or other dealings in this Software without prior written       
# authorization.          
#
# ---------------------------------------------------------------------------
#  Author: Jrgen Pfeifer <Juergen.Pfeifer@T-Online.de>
# ---------------------------------------------------------------------------
#
# GNU Ada RPM Packaging for LAPACK
#
%define        GNAT_TARGET_ARCH    i386
%define        COMPAT_TARGET_ARCH  i386 i486 i586 i686
%define        GNAT_TARGET_OS      Linux
%define        TARGET_OS           linux 
#
%define        BASE_NAME           gnat
%define        GNAT_PKG_NAME       gnat-3.11p
%define        GNAT_VERSION        3.11p
%define        GNAT_PKG_VERSION    1
%define        GNAT_PKG_RELEASE    12
%define        GCC_VERSION         2.8.1
%define        GDB_VERSION         4.17
#
%define        DEF_USER       bin
%define        DEF_GROUP      bin
#
%define        BASE_VERSION   gcc-%{GCC_VERSION}
#
%define        CFG_PREFIX     /usr
%define        ADA_ROOT       /lib/gnat
%define        ADA_BASE       %{CFG_PREFIX}%{ADA_ROOT}
#
%define        GNAT_SO_MAJOR  %{GNAT_PKG_VERSION}
%define        GNAT_SO_MINOR  %{GNAT_PKG_RELEASE}
#
%define        RPM_C_FLAGS     -O3 -m486 -fomit-frame-pointer
%define        RPM_ADA_FLAGS   -gnatpn
#
%define        THREADLIBS     -lpthread
#
%define        GNAT_NAME      gnat-%{GNAT_VERSION}
%define        GNAT_SO        %{GNAT_NAME}
%define        GNAT_DIR       %{ADA_BASE}/%{GNAT_NAME}
#
%define        AINC_NAME      adainclude
%define        AINC_DIR       %{ADA_BASE}/%{AINC_NAME}
#
%define        ALIB_NAME      adalib
%define        ALIB_DIR       %{ADA_BASE}/%{ALIB_NAME}
#
%define        ETC_NAME       etc
%define        ETC_DIR        %{ADA_BASE}/%{ETC_NAME}
#
%define        COMPAT_NAME    act_compat-%{GNAT_VERSION}
%define        COMPAT_DIR     %{ADA_BASE}/%{COMPAT_NAME}
#
%define        ASIS_NAME      asis-%{GNAT_VERSION}
%define        ASIS_SO        %{ASIS_NAME}
%define        ASIS_DIR       %{ADA_BASE}/%{ASIS_NAME}
#
%define        GLADE_NAME     glade-%{GNAT_VERSION}
%define        GLADE_DIR      %{ADA_BASE}/%{GLADE_NAME}
#dnl
#
%define        PKG_NAME       x11ada
%define        PKG_VERSION    1.30
%define        PKG_RELEASE    1
#
%define        X11ADA_DIR     x11ada
#
# ---------------------------------------------------------------------------
# We restrict the use of this package scipt at the moment to Intel and Linux.
# For sure there are details (compiler options, shared library building)
# that must be fixed for other architectures and OSes.
#
ExclusiveArch: %{COMPAT_TARGET_ARCH}
ExclusiveOS:   %{GNAT_TARGET_OS}
Packager:      Jrgen Pfeifer <Juergen.Pfeifer@t-online.de>
Distribution:  ALT (Ada for Linux Team)
Version:       %{PKG_VERSION}
Release:       %{PKG_RELEASE}
Name:          %{PKG_NAME}
BuildRoot:     /var/tmp/%{PKG_NAME}-%{version}-root
Autoreq:       No
Autoreqprov:   No
# ---------------------------------------------------------------------------
# These are the official sources
Source0:       x11ada_v1.30.tar.gz
Source1:       motif.tar.gz
#
# This is our patch
Patch0:        x11ada.diff
#
#  ---------------------------------------------------------------------------
Copyright:     (C)1994 Intermetrics. Free to use, modify and distribute.
Summary:       Runtime libraries for the X11 binding.
Summary(de):   Laufzeit-Bibliotheken des X11 Bindings
Group:         Libraries
Obsoletes:     %{name}
Provides:      libX11Ada.so
Requires:      %{GNAT_PKG_NAME} >= %{GNAT_PKG_VERSION}
Icon:          adarts.gif
Prefix:        %{CFG_PREFIX}
#
%description
This package includes the shared libraries required to run programs compiled
with the X11 binding.
#
%description -l de
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit dem X11 Binding bersetzt wurden.
#
#  ---------------------------------------------------------------------------
%package devel
Summary:       Ada95 Packages for the X11 binding.
Summary(de):   Ada95 Pakete fr das X11 Binding.
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name} = %{version}
Obsoletes:     %{name}-devel
Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description devel
This is a set of Ada packages that allows you to write programs using the
X11 windowing system.
#
%description -l de devel
Dies ist ein Sammlung von Ada Pakten die es Ihnen erlaubt, GNU Ada (GNAT)
Programme zu schreiben, die das X11 Window-System benutzen.
#
#  ---------------------------------------------------------------------------
%package motif
Summary:       Ada95 Runtime library for the X11 Motif binding.
Summary(de):   Ada95 Laufzeitbibliothek fr das X11 Motif Binding.
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name} = %{version}
Obsoletes:     %{name}-motif
# Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description motif
This package includes the shared libraries required to run programs compiled
with the X11 Motif binding.
#
%description -l de motif
Dieses Paket enthlt die Shared Libraries die zur Ausfhrung von Programmen
bentigt werden, die mit dem X11 Motif Binding bersetzt wurden.
#
#  ---------------------------------------------------------------------------
%package motif-devel
Summary:       Ada95 Packages for the X11 Motif binding.
Summary(de):   Ada95 Pakete fr das X11 Motif Binding.
Group:         Libraries
Requires:      %{GNAT_PKG_NAME}-devel >= %{GNAT_PKG_VERSION}
Requires:      %{name}-motif = %{version}
Obsoletes:     %{name}-motif-devel
# Icon:          adasmall.gif
Prefix:        %{CFG_PREFIX}
#
%description motif-devel
This is a set of Ada packages that allows you to write programs using the
X11 Motif Graphical User Interface.
#
%description -l de motif-devel
Dies ist ein Sammlung von Ada Pakten die es Ihnen erlaubt, GNU Ada (GNAT)
Programme zu schreiben, die die grafische Benutzrschnittstelle X11 Motif
verwenden. 
#
#-----------------------------------------------------------------------------
%prep
#=============================================================================
#
%setup -c -q -n %{X11ADA_DIR}
%setup -c -T -n %{X11ADA_DIR}
%setup -a 1 -D -c -n %{X11ADA_DIR}
%patch0 -p1
#
#-----------------------------------------------------------------------------
%build
#=============================================================================
# Create the required directory structure for the binary package
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{AINC_DIR}
mkdir -p $RPM_BUILD_ROOT%{ALIB_DIR}
mkdir -p $RPM_BUILD_ROOT/doc/test
mkdir -p $RPM_BUILD_ROOT%{CFG_PREFIX}/lib
#
./build
#
#-----------------------------------------------------------------------------
%install
#=============================================================================
OS=%{TARGET_OS}
#
cd ada
cp -pf *.ad? $RPM_BUILD_ROOT%{AINC_DIR}
cd ../obj
cp -pf ex*.o $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf *.ali $RPM_BUILD_ROOT%{ALIB_DIR}
cp -pf *.a   $RPM_BUILD_ROOT%{ALIB_DIR}
cd ../obj_s
cp -pf *.so  $RPM_BUILD_ROOT%{CFG_PREFIX}/lib
cd ..
#
strip $RPM_BUILD_ROOT%{CFG_PREFIX}/lib/libX*.so
#
ln -sf ../../libX11Ada.so ${RPM_BUILD_ROOT}%{ALIB_DIR}/libX11Ada.so
ln -sf ../../libXmAda.so  ${RPM_BUILD_ROOT}%{ALIB_DIR}/libXmAda.so
#
cp -pf  README*   $RPM_BUILD_ROOT/doc
cp -pf  doc/*	  $RPM_BUILD_ROOT/doc
cp -prf test/*    $RPM_BUILD_ROOT/doc/test
#
if [ -d ${RPM_BUILD_ROOT}%{AINC_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{AINC_DIR} -type f -name '*.ad?' -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{ALIB_DIR} ]; then
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.ali' -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}%{ALIB_DIR} -type f -name '*.a'   -exec chmod 0444 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib ]; then
  find ${RPM_BUILD_ROOT}%{CFG_PREFIX}/lib -type f -name '*.so*' -exec chmod 0755 {} \;
fi
if [ -d ${RPM_BUILD_ROOT}/doc ]; then
  find ${RPM_BUILD_ROOT}/doc -type f -exec chmod 0444 {} \;
  find ${RPM_BUILD_ROOT}/doc -type d -exec chmod 0755 {} \;
fi
#  ---------------------------------------------------------------------------
%pre devel
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%pre
if [ -f /etc/profile.d/%{BASE_NAME}-rts.sh ]; then
  source /etc/profile.d/%{BASE_NAME}-rts.sh
  if [ ! -z ${GNAT_ROOT} ]; then
    if [ "${GNAT_ROOT}" != "${RPM_INSTALL_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed with --prefix=${GNAT_ROOT}" >&2
      echo "You must use the same prefix with this package." >&2
      exit 1
    fi
  else
    if [ "${RPM_INSTALL_PREFIX}" != "%{CFG_PREFIX}" ]; then
      echo "%{BASE_NAME} was installed without the --prefix option." >&2
      echo "You must do this also with this package." >&2
      exit 1
    fi
  fi
fi
#  ---------------------------------------------------------------------------
%post
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%postun
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%post motif
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%postun motif
/sbin/ldconfig
#  ---------------------------------------------------------------------------
%files devel
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%doc $RPM_BUILD_ROOT/doc/*
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{AINC_DIR}/x*
%{AINC_DIR}/s*
%{AINC_DIR}/e*
%{ALIB_DIR}/x*
%{ALIB_DIR}/e*
%{ALIB_DIR}/s*
%{ALIB_DIR}/libadastdarg.a
%{ALIB_DIR}/libX11Ada.*
#  ---------------------------------------------------------------------------
%files
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%{CFG_PREFIX}/lib/libX11Ada.so
#  ---------------------------------------------------------------------------
%files motif
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%{CFG_PREFIX}/lib/libXmAda.so
#  ---------------------------------------------------------------------------
%files motif-devel
%defattr(-,%{DEF_USER},%{DEF_GROUP})
%dir %{CFG_PREFIX}
%dir %{CFG_PREFIX}/lib
%dir %{ADA_BASE}
%dir %{AINC_DIR}
%dir %{ALIB_DIR}
%{AINC_DIR}/m*
%{ALIB_DIR}/m*
%{ALIB_DIR}/libXmAda.*
#  ---------------------------------------------------------------------------
#
#  ---------------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT
#  ---------------------------------------------------------------------------
#
%changelog
* Mon Apr 26 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Publised as Release 1

* Sun Apr 25 1999 Juergen Pfeifer <juergen.pfeifer@t-online.de>
- Created
